%global _lto_cflags %{nil}

Summary: OpenMP runtime library of LLVM
Name:    libomp
Version: 17.0.6
Release: 1%{?dist}
License: NCSA
URL:     http://openmp.llvm.org
Source0: https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}/openmp-%{version}.src.tar.xz

%define maj_ver %(echo %{version} | cut -d. -f1)
 
BuildRequires: clang clang-tools-extra
BuildRequires: cmake ninja-build
BuildRequires: elfutils-libelf-devel libffi-devel
BuildRequires: perl perl-Data-Dumper perl-Encode 
BuildRequires: llvm-devel llvm-cmake-utils
 
Requires: elfutils-libelf
 
%description
OpenMP subproject of LLVM.
 
%package devel
Summary:  OpenMP header files
Requires: clang-resource-filesystem = %{version}
 
%description devel
Development libraries and header files for using OpenMP.
 
%prep
%autosetup -n openmp-%{version}.src -p2
 
%build

# libomp don't have LLVM_COMMON_CMAKE_UTILS, use cmake from llvm-cmake-utils
ln -s %{_datadir}/llvm/cmake ../cmake

%cmake	-GNinja \
	-DLIBOMP_INSTALL_ALIASES=OFF \
	-DLLVM_DIR=%{_libdir}/cmake/llvm \
	-DCMAKE_INSTALL_INCLUDEDIR=%{_libdir}/clang/%{maj_ver}/include \
	-DOPENMP_LIBDIR_SUFFIX=64 \
	-DCMAKE_SKIP_RPATH:BOOL=ON

%cmake_build

%install
%cmake_install

rm -rf %{buildroot}%{_libdir}/libarcher_static.a

# not provides *.bc
rm -rf %{buildroot}%{_libdir}/libomptarget-*.bc

%check
# don't run testcase omp_detach_taskwait in aarch64
%ifarch aarch64
rm -f runtime/test/tasking/omp_detach_taskwait.c
%endif
%cmake_build --target check-openmp

%files
%license LICENSE.TXT
%{_libdir}/libomp.so
%{_libdir}/libompd.so
%{_libdir}/libarcher.so
%{_libdir}/libomptarget.rtl.amdgpu.so.%{maj_ver}
%{_libdir}/libomptarget.rtl.cuda.so.%{maj_ver}
%{_libdir}/libomptarget.rtl.%{_arch}.so.%{maj_ver}
%{_libdir}/libomptarget.so.%{maj_ver}

%files devel
%{_libdir}/clang/%{maj_ver}/include/omp.h
%{_libdir}/cmake/openmp/FindOpenMPTarget.cmake
%{_libdir}/clang/%{maj_ver}/include/omp-tools.h
%{_libdir}/clang/%{maj_ver}/include/ompt.h
%{_libdir}/clang/%{maj_ver}/include/ompt-multiplex.h
%{_libdir}/libomptarget.rtl.amdgpu.so
%{_libdir}/libomptarget.rtl.cuda.so
%{_libdir}/libomptarget.rtl.%{_arch}.so
%{_libdir}/libomptarget.devicertl.a
%{_libdir}/libomptarget.so

%changelog
* Fri Dec 15 2023 Upgrade Robot <upbot@opencloudos.org> - 17.0.6-1
- Upgrade to version 17.0.6

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 16.0.6-2
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Jul 13 2023 kianli <kianli@tencent.com> - 16.0.6-1
- Upgrade to 16.0.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.0.5-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.0.5-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov  8 2022 Xiaojie Chen <jackxjchen@tencent.com> - 14.0.5-2
- Don't run testcase omp_detach_taskwait in aarch64

* Fri Jul 29 2022 Wang Zhe <bessiewang@tencent.com> - 14.0.5-1
- initial build
